#include "stdafx.h"
#include "afxwinappex.h"

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

#include <platform.h>
#include <objmodel.h>

#include "graphwnd.h"

IMPLEMENT_DYNAMIC(CGraphWnd, CWnd)

BEGIN_MESSAGE_MAP(CGraphWnd, CWnd)
  ON_WM_CLOSE()
  ON_WM_CREATE()
  ON_WM_DESTROY()
  ON_WM_SIZE()
END_MESSAGE_MAP()

// -------------------------------------------------------------------------
// Start of IGraphWnd interface
// -------------------------------------------------------------------------

void
CGraphWnd::deviceChanged()
{
  m_pScope->deviceChanged();
  m_pToolbar->deviceChanged();
}

void
CGraphWnd::setIndex(
  unsigned int index)
{
  m_index = index;
  m_pToolbar->setIndex(index);
}

// -------------------------------------------------------------------------
// End of IGraphWnd interface
// -------------------------------------------------------------------------

CGraphWnd::CGraphWnd(
  ISysMonWnd* pParent,
  unsigned int index,
  bool_t bVisible)
{
  const TCHAR* pWndClass = NULL;
  bool_t bSuccess;

  m_pParent = pParent;
  m_pToolbar = NULL;
  m_pScope = NULL;
  m_index = index;

  pWndClass = AfxRegisterWndClass(0, ::LoadCursor(NULL, IDC_ARROW), NULL, NULL);
  bSuccess = CreateEx(WS_EX_STATICEDGE | WS_EX_CONTROLPARENT, pWndClass, _T(""), WS_CHILD | (bVisible ? WS_VISIBLE : 0), 0, 0, 1, 1, *dynamic_cast<CWnd*>(m_pParent), NULL, NULL);
  ASSERT(bSuccess);
}

CGraphWnd::~CGraphWnd()
{
}

void
CGraphWnd::OnDestroy()
{
  CWnd::OnDestroy();

  if (NULL != m_pToolbar) {
    m_pToolbar->getNativeControl().DestroyWindow();
    delete m_pToolbar;
    m_pToolbar = NULL;
  }
  if (NULL != m_pScope) {
    m_pScope->getNativeControl().DestroyWindow();
    delete m_pScope;
    m_pScope = NULL;
  }
}

int
CGraphWnd::OnCreate(
  LPCREATESTRUCT lpCreateStruct)
{
  if (CWnd::OnCreate(lpCreateStruct) == -1) {
    return -1;
  }

  m_pToolbar = getFactory().createGraphWndToolbar(this, m_index);
  m_pScope = getFactory().createScopeWnd(this);

  return 0;
}

void
CGraphWnd::OnSize(
  UINT nType,
  int cx,
  int cy)
{
  CWnd::OnSize(nType, cx, cy);

  m_pToolbar->getNativeControl().MoveWindow(0, 0, cx, 32);
  m_pScope->getNativeControl().MoveWindow(0, 32, cx, cy - 32);
}
