#pragma once

#include <objmodel.h>
#include "iconbutton.h"

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

class CGraphWndToolbar : public CWnd, public IGraphWndToolbar
{
	DECLARE_DYNAMIC(CGraphWndToolbar)

public:
	CGraphWndToolbar(IGraphWnd* pParent, unsigned int index);
	virtual ~CGraphWndToolbar();
  // IGraphWndToolbar interface
  void deviceChanged();
  control_handle_t getNativeControl() { return *this; }
  IGraphWnd* getParent() const { return m_pParent; }
  bool_t getPaused() const { return m_bPaused; }
  void numGraphWndChanged();
  void numTraceChanged();
  void setIndex(unsigned int index);

protected:
  IGraphWnd* m_pParent;
  CFont m_font;
  CBrush m_bgBrush;
  CBrush m_fgBrush;
  CBrush m_keyBgBrush;
  CStatic m_captionCtl;
  CStatic m_keyCtl;
  CIconButton m_tempCtl;
  CIconButton m_voltCtl;
  CIconButton m_ampCtl;
  CIconButton m_boolCtl;
  CIconButton m_pauseCtl;
  CIconButton m_goCtl;
  CIconButton m_closeCtl;
  CIconButton m_plusCtl;
  CToolTipCtrl m_toolTipCtl;
  CToolTipCtrl m_keyTipCtl;
  unsigned int m_index;
  POINT m_requiredKeySize;
  bool_t m_bPaused;

protected:
  void addSensors(ADMXRC3_DATA_TYPE datatype);
  void addSensors(ADMXRC3_UNIT_TYPE unit);
  void adjustScale(float value);
  void drawKey(HDC hDC);
  virtual bool_t PreTranslateMessage(MSG* pMsg);

  DECLARE_MESSAGE_MAP()

protected:
  afx_msg void OnButtonAmp();
  afx_msg void OnButtonBool();
  afx_msg void OnButtonClose();
  afx_msg void OnButtonGo();
  afx_msg void OnButtonPause();
  afx_msg void OnButtonPlus();
  afx_msg void OnButtonVolt();
  afx_msg void OnButtonTemp();
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
  afx_msg void OnCustomDraw(UINT nControlId, NMHDR* pNotifyStruct, LRESULT* pResult);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnToolTipShow(UINT nControlId, NMHDR* pNotifyStruct, LRESULT* pResult);
};
