#include "stdafx.h"
#include "afxwinappex.h"

#ifdef _DEBUG
# define new DEBUG_NEW
#endif

#include <platform.h>
#include <objmodel.h>

#include "sysmonapp.h"

BEGIN_MESSAGE_MAP(CSysMonApp, CWinApp)
END_MESSAGE_MAP()

static CSysMonApp theApp;

CSysMonApp::CSysMonApp()
{
  m_returnCode = 0;
  m_pMainWnd = NULL;
}

bool_t
CSysMonApp::InitInstance()
{
  // InitCommonControlsEx() is required on Windows XP if an application
  // manifest specifies use of ComCtl32.dll version 6 or later to enable
  // visual styles.  Otherwise, any window creation will fail.
  INITCOMMONCONTROLSEX InitCtrls;
  InitCtrls.dwSize = sizeof(InitCtrls);
  InitCtrls.dwICC = ICC_WIN95_CLASSES | ICC_BAR_CLASSES | ICC_PROGRESS_CLASS;
  InitCommonControlsEx(&InitCtrls);

  CWinApp::InitInstance();

  m_pSysMonWnd = getFactory().createSysMonWnd();
  if (NULL == m_pSysMonWnd) {
    return FALSE;
  }
  m_pMainWnd = dynamic_cast<CWnd*>(m_pSysMonWnd);

  // Lower our process priority, so that we can run nicely in the background
  HANDLE hOurProcess = GetCurrentProcess();
  bool_t bSuccess = SetPriorityClass(hOurProcess, BELOW_NORMAL_PRIORITY_CLASS);
  ASSERT(bSuccess);

  return TRUE;
}

int CSysMonApp::ExitInstance()
{
  if (NULL != m_pSysMonWnd) {
    delete m_pSysMonWnd;
    m_pSysMonWnd = NULL;
  }

  CWinApp::ExitInstance();

  return m_returnCode;
}

bool_t
CSysMonApp::OnIdle(
  LONG /* lCount */)
{
  m_pSysMonWnd->idle();

  return 0;
}
