quit -sim

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"

vcom -93 "../../../common/adb3_target/adb3_target_types_pkg.vhd"
vcom -93 "../../../common/adb3_target/admxrc6tl/adb3_target_inc_sim_mptl_6tl_pkg.vhd"
vcom -93 "../../../common/adb3_target/adb3_target_pkg.vhd"

vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_simple_bus_if.vhd"

# MPTL interface
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_target_6tl_slv.vhd"
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_target_6tl_sim.vhd"
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_target_6tl_top.vhd"
vcom -93 "../../../common/mptl/mptl_if_target_wrap.vhd"

# Simple design
vcom -93 "../common/simple_l.vhd"

# Testbench packages
vcom -93 "../../../common/adb3_target/adb3_target_tb_pkg.vhd"

# MPTL interface
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_bridge_6tl_slv.vhd"
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_bridge_6tl_sim.vhd"
vcom -93 "../../../common/mptl/admxrc6tl/mptl64par_interface_bridge_6tl_top.vhd"
vcom -93 "../../../common/mptl/mptl_if_bridge_wrap.vhd"

# Testbench
vcom -93 "../common/test_simple.vhd"

vsim -t ps test_simple

set var_board  [examine /adb3_target_inc_pkg/BOARD_TYPE]
set var_use    [examine /adb3_target_inc_pkg/TARGET_USE]

set wave_pat {
/test_simple/*
/test_simple/uut/*
}

set wave_rad {
hexadecimal {data q}
}

#noview *
view signals
view structure
view wave -title "Simple(${var_board},${var_use})"

foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

foreach {radix signals} $wave_rad {
foreach signal $signals {
catch {property wave -radix $radix $signal}
}
}

radix hex

run 5us
